import { __require as requireFillRange } from '../../../../fill-range@7.1.1/node_modules/fill-range/index.mjs';
import { __require as requireUtils } from './utils.mjs';

var compile_1;
var hasRequiredCompile;
function requireCompile() {
  if (hasRequiredCompile) return compile_1;
  hasRequiredCompile = 1;
  const fill = requireFillRange();
  const utils = requireUtils();
  const compile = (ast, options = {}) => {
    const walk = (node, parent = {}) => {
      const invalidBlock = utils.isInvalidBrace(parent);
      const invalidNode = node.invalid === true && options.escapeInvalid === true;
      const invalid = invalidBlock === true || invalidNode === true;
      const prefix = options.escapeInvalid === true ? '\\' : '';
      let output = '';
      if (node.isOpen === true) {
        return prefix + node.value;
      }
      if (node.isClose === true) {
        console.log('node.isClose', prefix, node.value);
        return prefix + node.value;
      }
      if (node.type === 'open') {
        return invalid ? prefix + node.value : '(';
      }
      if (node.type === 'close') {
        return invalid ? prefix + node.value : ')';
      }
      if (node.type === 'comma') {
        return node.prev.type === 'comma' ? '' : invalid ? node.value : '|';
      }
      if (node.value) {
        return node.value;
      }
      if (node.nodes && node.ranges > 0) {
        const args = utils.reduce(node.nodes);
        const range = fill(...args, {
          ...options,
          wrap: false,
          toRegex: true,
          strictZeros: true
        });
        if (range.length !== 0) {
          return args.length > 1 && range.length > 1 ? `(${range})` : range;
        }
      }
      if (node.nodes) {
        for (const child of node.nodes) {
          output += walk(child, node);
        }
      }
      return output;
    };
    return walk(ast);
  };
  compile_1 = compile;
  return compile_1;
}

export { requireCompile as __require };
